image: google/cloud-sdk:slim

stages:
    - test
    - deploy
    
before_script:
    - apt-get install -y make
    - make install-dev

unit_testing:
    stage: test
    script:
        - make test

code_coverage:
    stage: test
    script:
        - make test-coverage
        
deploy to app engine:
    stage: deploy
    before_script:
    when: on_success
    script:
        - echo $SERVICE_ACCOUNT > /tmp/$CI_PIPELINE_ID.json
        - gcloud auth activate-service-account --key-file /tmp/$CI_PIPELINE_ID.json
        - gcloud app deploy app.yaml --quiet --version $CI_COMMIT_SHORT_SHA --project $PROJECT_ID
    after_script:
        - rm /tmp/$CI_PIPELINE_ID.json
        
